/***************************************************************************
                          particulas.h  -  description
                             -------------------
    begin                : Sun Feb 25 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PARTICULAS_H
#define PARTICULAS_H


/**Intentara ser la que maneje el sistema de 
particulas, veamos que sale de aca ...
  *@author Ricardo Markiewicz
  */

#include <SDL.h>
#include "graficos_lib.h"
#include "matematica.h"
#include "niveles.h"
#include "objetos.h"
#include "constantes.h"

/* defino las estructuras */
typedef enum {PARTICULA_LINEAL, PARTICULA_CIRCULAR} t_Efecto;

typedef struct 
{
  Uint16 xpos,ypos,xdir,ydir;
  Uint8 colorindex;
  Uint8 dead;
} t_Particula;

typedef struct _par_param {
	t_Efecto ef; /* tipo de efecto a realizar */
	Punto2D pos; /* posicion inicial */
	Punto2D dir; /* direccion, aplicable a PARTICULA_LINEAL */
	Uint16 cant; /* cantidad de particulas */
	SDL_Color colors[256];
} t_Part_Parametro;

#define WIDTH 200

class Controlador;

class Particulas: public Objetos {
public: 
	Particulas(Niveles *niv, Controlador *c, t_Part_Parametro *param);
	virtual ~Particulas();
	virtual void Dibujar();
	virtual void Mover();
	virtual bool isAlive();
private:
	Uint32 fire[WIDTH * WIDTH];
	Uint32 paleta[256];
	SDL_Surface *back_end; /* aca dibujo */
	Niveles *nivel;
	t_Particula *particulas;
	Uint16 total;
	bool dibuje;
};

#endif