/***************************************************************************
                          armas.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "armas.h"
#include "controlador.h"

Armas::Armas(Niveles *niv, Controlador *c, bool es_malo, int i, int dir):Objetos(niv,c, i)
{
	explode = false;
	malo = es_malo;
	if (es_malo)
		control->AddObjetoMalo(this);
	else
		control->AddObjetoBueno(this);
	direccion = dir;

	switch (direccion) {
		case (GO_LEFT):
			vel = Punto2D(-5, 0);
			acel = Punto2D(-0.2, 0);
		break;
		case (GO_RIGHT):
			vel = Punto2D(5, 0);
			acel = Punto2D(0.2, 0);
		break;
		case (GO_UP):
			vel = Punto2D(0, 5);
			acel = Punto2D(0, 0.2);
		break;
		case (GO_DOWN):
			vel = Punto2D(0, -5);
			acel = Punto2D(0, -0.2);
		break;
		case (GO_LEFTUP):
			vel = Punto2D(-3.535, 3.535);
			acel = Punto2D(-0.16, 0.16);
		break;
		case (GO_RIGHTUP):
			vel = Punto2D(3.535, 3.535);
			acel = Punto2D(0.16, 0.16);
		break;
		case (GO_LEFTDOWN):
			vel = Punto2D(-3.535, -3.535);
			acel = Punto2D(-0.16, -0.16);
		break;
		case (GO_RIGHTDOWN):
			vel = Punto2D(3.535, -3.535);
			acel = Punto2D(0.16, -0.16);
		break;
	}
}

Armas::~Armas()
{
}

void Armas::Mover()
{
	pos += vel*Gra_SpeedFactor();
	vel += acel*Gra_SpeedFactor();
	if (!current->isInside(this))
		life = -1;
}
