/***************************************************************************
                          button.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "button.h"


Button::Button(Form *p, int x, int y, int f, char *t, int _action):FormObj(p)
{
	fuente = f;
	r.x = x;
	r.y = y;
	r.w = Gra_TextWidth(fuente, t) + 4;
	r.h = Gra_TextHeight(fuente, t) + 2;
	txt = new char[strlen(t)+1];
	strcpy(txt, t);
	action = _action;
	pressed = false;
	on_click = NULL;
	alinear = TEXT_LEFT;
	can_focus = true;
	imagen = -1;
}

Button::Button(Form *p, int x, int y, int w, int h, int f, char *t, int _action):FormObj(p)
{
	fuente = f;
	r.x = x;
	r.y = y;
	r.w = w;
	r.h = h;
	txt = new char[strlen(t)+1];
	strcpy(txt, t);
	action = _action;
	pressed = false;
	on_click = NULL;
	alinear = TEXT_LEFT;
	can_focus = true;
	imagen = -1;
}

Button::~Button()
{
	delete [] txt;
}

void Button::Dibujar(bool focus)
{
	int x;
	if (!visible) return;

	if (pressed)
		Gra_DrawBox3D(r.x, r.y, r.w, r.h, 0, parent->background, true, T3D_IN);
	else
		Gra_DrawBox3D(r.x, r.y, r.w, r.h, 0, parent->background, true, T3D_OUT);
	if ((focus) && (!pressed))
		Gra_DrawBox(r.x-1, r.y-1, r.w+2, r.h+2, 0);
	switch (alinear) {
		case (TEXT_LEFT):
			x = r.x+2;
			break;
		case (TEXT_CENTER):
			x = r.x+r.w/2 - Gra_TextWidth(fuente, txt)/2;		
			break;
		case (TEXT_RIGHT):
			x= r.x+r.w - Gra_TextWidth(fuente, txt) - 2;
	}
	if (imagen == -1 )
		Gra_Print(x, r.y+1, fuente, &parent->text_normal, -1, false, txt);
	else
		Gra_BlitImagen(imagen, NULL, &r);
}

void Button::setFocus()
{
}

void Button::eventKeyDown(SDL_KeyboardEvent *key)
{
	switch (key->keysym.sym) {
		case (SDLK_RETURN):
			pressed = true;
		break;
	}
}

void Button::eventKeyUp(SDL_KeyboardEvent *key)
{
	switch (key->keysym.sym) {
		case (SDLK_ESCAPE):
			parent->Done();
		break;
		case (SDLK_TAB):
			parent->NextFocus(this);
		break;
		case (SDLK_RETURN):
			pressed = false;
	}
}

void Button::eventMouseDown(SDL_MouseButtonEvent *button)
{
	if (!isMouseOver(button->x, button->y)) return;
	if (button->button==SDL_BUTTON_LEFT) {
		pressed = true;
	}
}

void Button::eventMouseUp(SDL_MouseButtonEvent *e)
{
	if ((pressed) && (isMouseOver(e->x, e->y))) {
		switch (action) {
			case (Form::OK):
			case (Form::CANCEL):
				if (on_click)
					on_click();
				parent->setAction(action);
				parent->Done();
			break;
			default:
				if (on_click)
					sendMessage(on_click());
				else
					sendMessage(action);
		}
	}
	sendMessage(FormObj::CLICKED_EVENT);
	pressed = false;
}

void Button::eventMouseMove(SDL_MouseMotionEvent *e)
{
}
