/***************************************************************************
                          checkbox.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "checkbox.h"

CheckBox::CheckBox(Form *p, int x, int y, int f, char *txt, bool mar):FormObj(p)
{
	r.x = x;
	r.y = y;
	r.h = 20; //Gra_TextHeight(f, txt);
	r.w = Gra_TextWidth(f, txt) + r.h - 8;
	texto = new char[strlen(txt)+1];
	strcpy(texto, txt);
	fuente = f;
	marcado = mar;
}

CheckBox::~CheckBox()
{
	delete [] texto;
}

void CheckBox::Dibujar(bool focus)
{
	SDL_Rect dst;
	dst.x = r.x;
	dst.y = r.y;
	dst.w = dst.h = 20;
	if (marcado) {
		if (parent->check_select == -1)
			Gra_DrawBox3D(r.x, r.y+4, r.h-8, r.h-8, 0, 0, true);
		else
			Gra_BlitImagen(parent->check_select, NULL, &dst);
	} else {
		if (parent->check_normal == -1)
			Gra_DrawBox3D(r.x, r.y+4, r.h-8, r.h-8, 0, parent->background, true);
		else
			Gra_BlitImagen(parent->check_normal, NULL, &dst);
	}
	if (focus)
		Gra_Print(r.x+r.h, r.y, fuente, &parent->text_focus, -1, false, texto);
	else
		Gra_Print(r.x+r.h, r.y, fuente, &parent->text_normal, -1, false, texto);
}


void CheckBox::setFocus()
{
}

void CheckBox::eventKeyDown(SDL_KeyboardEvent *e)
{
}

void CheckBox::eventKeyUp(SDL_KeyboardEvent *e)
{
	if ((e->keysym.sym == SDLK_RETURN) || (e->keysym.sym == SDLK_SPACE))
		marcado = !marcado;
}

void CheckBox::eventMouseDown(SDL_MouseButtonEvent *e)
{
}

void CheckBox::eventMouseUp(SDL_MouseButtonEvent *e)
{
	if (!isMouseOver(e->x, e->y)) return;

	if (e->button == SDL_BUTTON_LEFT)
		marcado = !marcado;
}

void CheckBox::eventMouseMove(SDL_MouseMotionEvent *e)
{
}
