/***************************************************************************
                          config_menu.h  -  description
                             -------------------
    begin                : Thu Feb 8 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _CONFIG_MENU_H
#define _CONFIG_MENU_H

#include "graficos_lib.h"
#include "form.h"
#include "slider.h"
#include "button.h"
#include "label.h"
#include "checkbox.h"
#include "keyselect.h"
#include "notebook.h"
#include "option.h"
#include <SDL.h>

#ifdef LINUX
#include <dirent.h>
#include <sys/types.h>
#endif

#ifdef WIN32
#include <io.h>
#endif

extern void DrawOption(void);

class sldMusica:public Slider {
public:
	sldMusica(Form *p,int x,int y,int w,int h,int max):Slider(p,x,y,w,h,max) {}
	virtual ~sldMusica() {}
	virtual void eventKeyUp(SDL_KeyboardEvent *);
	virtual void eventMouseUp(SDL_MouseButtonEvent *);
	virtual void setFocus();
	virtual void lostFocus();
	void setMusica(char *);
protected:
	int musica;
};

class sldSonido:public Slider {
public:
	sldSonido(Form *p,int x,int y,int w,int h,int max):Slider(p,x,y,w,h,max) {}
	virtual ~sldSonido() {}
	virtual void eventKeyUp(SDL_KeyboardEvent *);
	virtual void eventMouseUp(SDL_MouseButtonEvent *);
	virtual void setFocus();
	virtual void lostFocus();
	void setSonido(char *);
protected:
	int sonido;
};

class optIdioma:public Option {
public:
	optIdioma(Form *form, int x, int y, int f):Option(form, x, y, f) {}
	~optIdioma() {}
	void receiveMessage(FormObj *, int);
};

void Configurar();

#endif