/***************************************************************************
                          enemigos.h  -  description
                             -------------------
    begin                : Wed Mar 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ENEMIGOS_H
#define ENEMIGOS_H

#include <SDL.h>
#include "objetos.h"
#include "matematica.h"
#include "graficos_lib.h"
#include "constantes.h"
#include "faser.h"
#include "energybar.h"

/**
  *@author Ricardo Markiewicz
  */

/* estados de los enemigos */
#define STATE_NORMAL 1
#define STATE_RANDOM 2
#define STATE_ATTACK 3
#define STATE_PATTERN 4
/* se tiene que retirar de la pantalla !! */
#define STATE_EXIT 0x05

/* patterns por default */
#define MOVE_CIRCLE 1
#define MOVE_DIAGONAL 2

class Enemigos : public Objetos  {
public: 
	Enemigos(Punto2D pos, Niveles *niv, Controlador *c, int _estado=1, int _pattern=2);
	~Enemigos();
	virtual void Mover();
	virtual void Dibujar();
protected:
	virtual void Fire(Punto2D);
	virtual void Pattern();
	virtual void Attack();
	virtual void Random();

	/* algunos patterns predefinidos */
	void Move_Circle();
	void Move_Diagonal();

	/* algunas variables */
	Punto2D vel;
	int img_cod;
	int estado, def_pattern;
	int calentamiento;

	float angulo;
	int vueltas;
	int dir;
};

#endif
