/***************************************************************************
                          faser.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "faser.h"

Faser::Faser(Punto2D pos_ini, Niveles *niv, Controlador *c, bool es_malo, int i, int dir):Armas(niv, c, es_malo, i, dir)
{
	pos = pos_ini;
	radio_choque = 3;
	damage = DANIO_FASER;
	life = 1;
	/*inicio colores*/
	colores[0] = Gra_GetColor(0xFF, 0x00, 0x00);
	colores[1] = Gra_GetColor(0xFF, 0x99, 0x00);
	colores[2] = Gra_GetColor(0xFF, 0xFF, 0x00);
	acel = Punto2D(0, 0.1);
	if (es_malo)
		imagen = Gra_LoadImage("Comunes/faser.png", true);
}

Faser::Faser(Punto2D pos_ini, Punto2D fin, Niveles *niv, Controlador *c, bool es_malo, int i,int dir):Armas(niv, c, es_malo, i, dir)
{
	pos = pos_ini;
	vel = pos.getDir(fin);
	acel = vel;
	acel *= 0.1;
	vel *= 5; /* le doy velocidad 4 */
	radio_choque = 3;
	damage = DANIO_FASER;
	life = 1;
	/*inicio colores*/
	colores[0] = Gra_GetColor(0xFF, 0x00, 0x00);
	colores[1] = Gra_GetColor(0xFF, 0x99, 0x00);
	colores[2] = Gra_GetColor(0xFF, 0xFF, 0x00);
	if (es_malo)
		imagen = Gra_LoadImage("Comunes/faser.png", true);
}

Faser::~Faser()
{
}

void Faser::Dibujar()
{
	Punto2D screen_pos = current->ScreenPos(pos);
	if (malo) {
		Gra_BlitImagen(imagen, NULL, screen_pos);
	} else {
		Gra_Lock();
		Gra_SetPixel((int)screen_pos.X(), (int)screen_pos.Y(), colores[2]); // 0
		Gra_SetPixel((int)screen_pos.X()+1, (int)screen_pos.Y(), colores[2]); //1
		Gra_SetPixel((int)screen_pos.X()-1, (int)screen_pos.Y(), colores[2]); //1
		Gra_SetPixel((int)screen_pos.X(), (int)screen_pos.Y()+1, colores[2]); //1
		Gra_SetPixel((int)screen_pos.X(), (int)screen_pos.Y()-1, colores[2]); //1
		Gra_SetPixel((int)screen_pos.X(), (int)screen_pos.Y()-2, colores[2]); //2
		Gra_SetPixel((int)screen_pos.X(), (int)screen_pos.Y()+2, colores[2]); //2
		Gra_SetPixel((int)screen_pos.X()-2, (int)screen_pos.Y(), colores[2]); //2
		Gra_SetPixel((int)screen_pos.X()+2, (int)screen_pos.Y(), colores[2]); //2
		Gra_SetPixel((int)screen_pos.X()+1, (int)screen_pos.Y()+1, colores[2]); //1
		Gra_SetPixel((int)screen_pos.X()+1, (int)screen_pos.Y()-1, colores[2]); //1
		Gra_SetPixel((int)screen_pos.X()-1, (int)screen_pos.Y()+1, colores[2]); //1
		Gra_SetPixel((int)screen_pos.X()-1, (int)screen_pos.Y()-1, colores[2]); //1
		Gra_Unlock();
	}
}
