/***************************************************************************
                          form.h  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FORM_H_
#define _FORM_H_

#include "lista.h"
#include "formobj.h"
#include "graficos_lib.h"

class Form {
public:
	enum {CANCEL, OK, ERROR, NONE};
	Form();
	Form(void (*f)(void));
	~Form();
	
	void addObject(FormObj *);
	void delObject(FormObj *);
	
	void NextFocus(FormObj *);
	
	int Go();
	void Update();
	void Done();
	void setDrawBackground(void (*f)(void)) { funcion = f; }
	void setAction(int);
	void setFocus(FormObj *o) { focus = o; }
private:
	Lista<FormObj> lista;
	FormObj *focus;
	bool done;
	void (*funcion)(void);
	FormObj *getObjIn(int x, int y);
	int action;

	void InitStyle();
	/* No hagan esto en sus casas.... aca es comodo */
public:
	/* Colores */
	SDL_Color color_fuente;
	Uint32 background;
	Uint32 list_item_select;
	Uint32 list_background;
	Uint32 text_background;
	Uint32 cursor_color;
	SDL_Color text_normal;
	SDL_Color text_focus;
	
	/* Option Theme */
	int option_normal, option_select;
	
	/* CheckBox Theme */
	int check_normal, check_select;
};

#endif