/***************************************************************************
                          formobj.h  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _FORMOBJ_H
#define _FORMOBJ_H

class Form;
class objConected;
#include "SDL.h"
#include "lista.h"


class FormObj {
public:
	/* comienza en 4 para no pisar el enum en clase Form */
	enum {KEY_EVENT=4, MOUSE_EVENT, UPDATE_EVENT, SELECT_EVENT, CLICKED_EVENT,
		DELETE_CURRENT_EVENT, KEY_VERIFY, RESET_CURRENT_PILOTO, CHANGE_EVENT};
	FormObj(Form *);
	virtual ~FormObj();
	
	virtual void Dibujar(bool focus) = 0;
	virtual void setFocus() = 0;
	virtual void lostFocus() {}

	bool canFocus() { return can_focus; }
	virtual int width() { return r.w; }
	virtual int height() { return r.h; }
	virtual int x() { return r.x; }
	virtual int y() { return r.y; }

	/* funciones de eventos */
	virtual void eventKeyDown(SDL_KeyboardEvent *) {}
	virtual void eventKeyUp(SDL_KeyboardEvent *) {}
	virtual void eventMouseDown(SDL_MouseButtonEvent *) {}
	virtual void eventMouseUp(SDL_MouseButtonEvent *) {}
	virtual void eventMouseMove(SDL_MouseMotionEvent *) {}

	virtual void Visible(bool o) { visible = o; }
	bool Visible() { return visible; }
	void connect(FormObj *, int);
	void disconnect(FormObj *);
	void sendMessage(int);
	virtual void receiveMessage(FormObj *, int) {};
	bool isMouseOver(int x, int y);
protected:
	Lista<objConected> conectados;
	SDL_Rect r;
	Form *parent;
	bool can_focus;
	bool visible;
};

class objConected {
public:
	objConected(FormObj *obj, int code) { _obj=obj; _code=code; }
	~objConected() {}

	FormObj *_obj;
	int _code;
};

#include "form.h"

#endif