/***************************************************************************
                          list.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "list.h"

List::List(Form *p, int x, int y, int w, int h, int f):FormObj(p)
{
	fuente = f;
	draw.x = r.x = x;
	draw.y = r.y = y;
	draw.w = w;
	r.w = w-15;
	draw.h = r.h = Gra_TextHeight(fuente, "M")*h;
	lineas = h;
	selected = offset = 0;
	btnUp = new Button(p, x+w-18, y+3, 15, 15, FONT_TIMES, ".", PREV);
	btnUp->setAlign(TEXT_CENTER);
	btnUp->connect(this, PREV);
	btnUp->setImagen( Gra_LoadImage("Forms/lstUp.png", true) );
	btnDown = new Button(p, x+w-18, y+r.h-18, 15, 15, FONT_TIMES, ".", NEXT);
	btnDown->setAlign(TEXT_CENTER);
	btnDown->connect(this, NEXT);
	btnDown->setImagen( Gra_LoadImage("Forms/lstDown.png", true) );
}

List::~List()
{
	char **c;
	for(c=items.First(); c; c=items.First()) {
		delete [] *c;
		delete c;
		items.Delete();
	}
	Gra_UnloadImage("Form/lstUp.png");
	Gra_UnloadImage("Form/lstDown.png");
//	delete btnUp;
//	delete btnDown;
}

void List::Dibujar(bool focus)
{
	char **c;
	int i, h;

	Gra_DrawBox3D(draw.x, draw.y, draw.w, draw.h, 0, parent->list_background, true);
	for(i=0, c=items.First(); i<offset; i++, c=items.Next()) {}
	
	h=0;
	for(i=offset; (i<lineas+offset) && (c!=NULL); c=items.Next(), i++) {
		if (selected == i)
			Gra_DrawBox(draw.x+2, draw.y+1+(draw.h/lineas)*(h), r.w-15, draw.h/lineas, parent->list_item_select, parent->list_item_select, true);
		Gra_Print(draw.x+4, draw.y+1+(draw.h/lineas)*(h++), fuente, (i==selected)?(&parent->text_focus):(&parent->text_normal), draw.w-8, false, *c);
	}
//	Gra_DrawBox3D(r.x+r.w-12, r.y+12, 10, r.h-24, parent->background, parent->background, true);
/*	Gra_DrawBox3D(r.x+r.w-12, r.y+2, 10, 10, 0, 0xFFFFFFFF, true, T3D_OUT);
	Gra_DrawBox3D(r.x+r.w-12, r.y+r.h-12, 10, 10, 0, 0xFFFFFFFF, true, T3D_OUT);*/
}

void List::setFocus()
{
	sendMessage(FormObj::SELECT_EVENT);
}

void List::eventKeyDown(SDL_KeyboardEvent *)
{
}

void List::eventKeyUp(SDL_KeyboardEvent *)
{
}

void List::eventMouseDown(SDL_MouseButtonEvent *)
{
}

void List::eventMouseUp(SDL_MouseButtonEvent *m)
{
	int t;
	if (!isMouseOver(m->x, m->y)) return;

	if (m->button == SDL_BUTTON_LEFT) {
		t = (m->y-r.y) / (r.h/lineas) + offset;
		Current(t);
	}
}

void List::eventMouseMove(SDL_MouseMotionEvent *)
{
}

void List::addItem(char *s, int i)
{
	char **c;
	c = new char *;
	*c = new char[strlen(s)+1];
	strcpy(*c, s);
	if (i<0) {
		items.Append(c);
	} else {
		items.InsertAt(i, c);
	}
}

void List::delItem(int i)
{
	items.Delete(i);
}

void List::Clean()
{
	items.First();
	char **c;
	while (items.Count() > 0) {
		c = items.At();
		items.Delete();
		delete [] *c;
		delete c;
	}
}

char *List::Value()
{
	int i;

	if (items.Count() == 0) return NULL;

	items.First();
	for(i=0; i<selected; i++)
		items.Next();
	
	return *(items.At());
}

void List::receiveMessage(FormObj *o, int cod)
{
	cout << "Mesage : " << cod << endl;
	switch (cod) {
		case (PREV):
			Prev();
		break;
		case (NEXT):
			Next();
	}
}

void List::Next()
{
	Current(++selected);
	if ((selected+offset) >= lineas) Offset(offset+1);	
}

void List::Prev()
{
	Current(--selected);
	if (selected < offset) Offset(offset-1);	
}

void List::Current(int i)
{
	selected = i;

	if (selected < 0) selected = 0;
	if (selected >= items.Count()) selected = items.Count()-1;

	/* Mando el MSG a los amigotes */
	sendMessage(SELECT_EVENT);
}

void List::Offset(int i)
{
	offset = i;

	if (offset<0) offset = 0;
	if (lineas+offset >= items.Count()) offset = items.Count()-lineas;
	if (items.Count() < lineas) offset = 0;
}

void List::Visible(bool o)
{
	visible = o;
	btnUp->Visible(o);
	btnDown->Visible(o);
}
