/***************************************************************************
                          matematica.h  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MATEMATICA_H
#define MATEMATICA_H

#include "math.h"
#include <SDL.h>

/**
  *@author Ricardo Markiewicz
  */

class Punto2D {
public: 
	Punto2D();
	Punto2D(float _x, float _y);
	~Punto2D();
	inline float Norma() { return (sqrt(x*x + y*y)); }
	inline float Angulo(Punto2D o) { return acos(x*o.X()+y*o.Y()); }
	inline float X() { return x; }
	inline float Y() { return y; }
	inline void setX(float _x) { x = _x; }
	inline void setY(float _y) { y = _y; }
	float dist(Punto2D o);
	Punto2D getDir(Punto2D fin);

	void operator /= (float i);
	void operator *= (float i);
	void operator += (Punto2D o);
	void operator -= (Punto2D o);
	bool operator == (Punto2D o);
	bool operator != (Punto2D o);

	Punto2D operator + (Punto2D o);
	Punto2D operator - (Punto2D o);
	Punto2D operator * (float f);
	void operator = (Punto2D o);
	SDL_Rect toRect(float w, float h);
protected:
	float x,y;
};

#endif
