/***************************************************************************
                          menu.c  -  Pantalla de menu inicial
                             -------------------
    begin                : Sun Mar 18 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "menu.h"
#define FPS 40
#define VEL_ANIM 5

/* Texto de Creditos */
char *creditos[] = {"Diseo y Programacin", "    Ricardo Markiewicz", \
				" ", " ", "Artes y Grficos", "    Ricardo Markiewicz", \
				" ", " ", "Msica y Sonidos", "    Ricardo Markiewicz", \
				" ", " ", "MS-Windows Testers", "    Nicols Dimov", \
				" ", " ", "Linux Testers", "    Ricardo Markiewicz"};

#define LINEAS_CREADITOS 18

Menu::Menu ()
{
	int i, j;
	char name[19];
	fondo = Gra_LoadImage("Menu/fondo.png");
	about = Gra_LoadImage("Menu/about.png");
	for(i=0; i<4; i++)
		for(j=0; j<7; j++)
		{
			sprintf(name, "Menu/op%i_anim%02i.png", i+1, j);
			opts[i][j] = Gra_LoadImage(name);
			Gra_SetColorKey(opts[i][j], 0, 0, 0);
		}
	current_opt = 0;
	vel_anim = VEL_ANIM;
	frame = 0;
}

Menu::~Menu ()
{
	int i, j;
	char name[19];
	Gra_UnloadImage("Menu/fondo.png");
	Gra_UnloadImage("Menu/about.png");
	for(i=0; i<4; i++)
		for(j=0; j<7; j++)
		{
			sprintf(name, "Menu/op%i_anim%02i.png", i+1, j);
			Gra_UnloadImage(name);
		}
}

int Menu::Choose ()
{
	static SDL_Color negro = {0,0,0,0};
	Uint32 frame_i, frame_f; /* para regular la velocidad */
	Uint32 double_click_start=0, double_click_end=0;
	bool done=false;
	bool exit=false;
	int mostrar = 0;
	SDL_Event event;
	Uint8 *keystate;
	FadeIn(fondo);
	frame_i = SDL_GetTicks();
	while (!exit)
	{
		while (SDL_PollEvent(&event))
		{
			switch (event.type)
			{
				case (SDL_MOUSEBUTTONUP):
					if (done) {
						done = false;
						FadeIn(fondo);
						mostrar = 0;
						break;
					}
					if ((event.button.x > 50) && (event.button.x < 300))
					{
						if ((event.button.y > 170) && (event.button.y < 230)) /* Opcion 1 */
							current_opt = 0;
						if ((event.button.y > 235) && (event.button.y < 295)) /* Opcion 2 */
							current_opt = 1;
						if ((event.button.y > 300) && (event.button.y < 360)) /* Opcion 3 */
							current_opt = 2;
						if ((event.button.y > 365) && (event.button.y < 425)) /* Opcion 4 */
							current_opt = 3;
					}
					if (double_click_start != 0)
						double_click_end = SDL_GetTicks();
					else
						double_click_start = SDL_GetTicks();
					if ((double_click_start!=0) && (double_click_end!=0))
						if ((double_click_end - double_click_start) < 1000)
						{
							if (done)
							{
								done = false;
								FadeIn(fondo);
								mostrar = 0;
							}
							else
							{
								if (current_opt == 2)
								{
									done = true;
									vertical_pos = 480;
									mostrar = 1;
									FadeIn(fondo);
								} else if (current_opt == 1) {
									mostrar = 2;
								}else {
									exit=true;
									mostrar = 0;
								}
							}
							double_click_end = 0;
							double_click_start = 0;
						} else {
							double_click_end = 0;
							double_click_start = 0;
						}
					break;
				case (SDL_KEYDOWN):
				{
					if (done) {
						done = false;
						FadeIn(fondo);
						mostrar = 0;
						break;
					}
					keystate = SDL_GetKeyState(NULL);
					if ((keystate[SDLK_DOWN] == SDL_PRESSED) && (!done))
					{
						frame = 0;
						vel_anim = 10;
						current_opt++;
						if (current_opt > 3) current_opt = 3;
					}
					if ((keystate[SDLK_UP] == SDL_PRESSED) && (!done))
					{
						frame = 0;
						vel_anim = 10;
						current_opt--;
						if (current_opt < 0) current_opt = 0;
					}
					if (keystate[SDLK_F3] == SDL_PRESSED)
						Gra_ToggleFullScreen();
					if (keystate[SDLK_RETURN] == SDL_PRESSED)
						if (done)
						{
							done = false;
							FadeIn(fondo);
							mostrar = 0;
						}
						else
						{
							if (current_opt == 2)
							{
								done = true;
								vertical_pos = 480;
								mostrar = 1;
								FadeIn(fondo);
							} else if (current_opt == 1) {
								mostrar = 2;
							}else {
								exit=true;
								mostrar = 0;
							}
						}
					if (keystate[SDLK_F12] == SDL_PRESSED)
						Gra_SaveScreen();
				}
			}
		}
		DrawMenu(mostrar);
		if (mostrar == 2) mostrar = 0;

		Gra_Print(ALIGN_H_CENTER, 100, FONT_LCD, &negro, -1, true, DEXTER_VERSION);
		Gra_Print(50, 460, FONT_LCD, &negro, -1, true, Gra_Idioma_Name());
		
		Gra_Update();
		/* restrinjo la velocidad del game ... */
		frame_f = SDL_GetTicks();
		if ((frame_f - frame_i) < (1000/(float)FPS))
			SDL_Delay(1000/FPS - (frame_f - frame_i));
		frame_i = frame_f;
	}
	return current_opt;
}

void Menu::DrawMenu(int o)
{
	static SDL_Color red = {0x00, 0, 0xaa, 0};
	SDL_Rect pos;
	int i;
	pos.x = 50;
	pos.y = 170;
	switch (o)
	{
		case (2): {
			Configurar();
			break;
		}
		case (1):
			Gra_BlitImagen(about, NULL, NULL);
			for(i=0; i<LINEAS_CREADITOS; i++)
				if (((vertical_pos+i*27) > 100) && ((vertical_pos+i*27) < 480)) {
					Gra_Print(52, vertical_pos + i*27+2, FONT_CREDITS, &red, -1, true, creditos[i]);
				}
		
			vertical_pos -= 1;
			if (vertical_pos < -27*LINEAS_CREADITOS) vertical_pos = 480;
			break;
		case (0):
			Gra_BlitImagen(fondo, NULL, NULL);
			for(i=0; i<4; i++)
			{
				if (i != current_opt) {
					pos.w = Gra_GetImagenWidth(opts[i][0]);
					pos.h = Gra_GetImagenHeight(opts[i][0]);
					Gra_BlitImagen(opts[i][0], NULL, &pos);
				} else {
					pos.w = Gra_GetImagenWidth(opts[i][frame]);
					pos.h = Gra_GetImagenHeight(opts[i][frame]);
					Gra_BlitImagen(opts[i][frame], NULL, &pos);
					if (vel_anim == 0)
					{
						frame++;
						if (frame > 6) frame = 1;
							vel_anim = VEL_ANIM;
					} else vel_anim--;
				}
				pos.y += pos.h + 5;
			}
	}
}

void Menu::FadeIn(int i)
{
	/* hago un fade in. ... */
	Uint32 alpha;
	for(alpha = 0; alpha<256; alpha +=10)
	{
		Gra_SetAlpha(i, SDL_SRCALPHA, alpha);
		Gra_BlitImagen(i, NULL, NULL);
		Gra_Update();
	}
	Gra_SetAlpha(i, 0, 0);
}

void DrawOption(void)
{
	Gra_BlitImagen(Gra_LoadImage("Menu/about.png"), NULL, NULL);
	Gra_DrawBox3D(30, 130, 580, 250, Gra_GetColor(255, 255, 255), Gra_GetColor(200, 200, 200), true, T3D_OUT);
}
