/*

C++ File

*/

#include "mpeg.h"

MPEGPlayer::MPEGPlayer(char *file, SDL_Surface *dst)
{
	mpeg = SMPEG_new(file, &info, 0);
	if (SMPEG_error(mpeg) != NULL) {
		Gra_Debug("MpegPlayer", "Constructor", "Error Cargando Video", WARNING);
		Gra_Debug("MpegPlayer", "Constructor", SMPEG_error(mpeg), WARNING);
		can_play = false;
	}
	SMPEG_getinfo(mpeg, &info );
	if (!info.has_video) {
		Gra_Debug("MpegPlayer", "Constructor FAIL", file, WARNING);
		can_play = false;
	} else {
		can_play = true;
		SMPEG_setdisplay(mpeg, dst, NULL, NULL);
	}
}


MPEGPlayer::~MPEGPlayer()
{
	SMPEG_delete(mpeg);
}

void MPEGPlayer::Play()
{
	bool done=false;
	SDL_Event event;

	if (!can_play) return;
	SMPEG_play(mpeg);
	while (!done) {
		if (SMPEG_status(mpeg) != SMPEG_PLAYING) done = true;
		
		/* verifico eventos para cortar la animacion */
		while (SDL_PollEvent(&event))
		{
			switch (event.type)
			{
				case (SDL_KEYUP):
					if (event.key.keysym.sym == SDLK_ESCAPE) {
						SMPEG_stop(mpeg);
						done = true;
					}
			}
		}
	}
}
