/***************************************************************************
                          navehumano.cpp  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "navehumano.h"
#include "controlador.h"

NaveHumano::NaveHumano(Niveles *niv, Controlador *c, Pilotos *p, int num):Objetos(niv, c, num)
{
	int x,y,w,h;
	/* cargo los datos de la nave */
	FILE *fp;
	char nave_dat[30];
	char nave_pic[30];

	switch (p->Piloto()) {
		case (FERNY):
			if (num == 0) {
				strcpy(nave_dat, "Naves/Ferny/nave_1.dat");
				strcpy(nave_pic, "Naves/Ferny/nave_1.png");
			} else {
				strcpy(nave_dat, "Naves/Ferny/nave_2.dat");
				strcpy(nave_pic, "Naves/Ferny/nave_2.png");
			}
			break;
		case (JORGE):
			if (num == 0) {
				strcpy(nave_dat, "Naves/Jorge/nave_1.dat");
				strcpy(nave_pic, "Naves/Jorge/nave_1.png");
			} else {
				strcpy(nave_dat, "Naves/Jorge/nave_2.dat");
				strcpy(nave_pic, "Naves/Jorge/nave_2.png");
			}
			break;
		case (SAGAR):
			if (num == 0) {
				strcpy(nave_dat, "Naves/Sagar/nave_1.dat");
				strcpy(nave_pic, "Naves/Sagar/nave_1.png");
			} else {
				strcpy(nave_dat, "Naves/Sagar/nave_2.dat");
				strcpy(nave_pic, "Naves/Sagar/nave_2.png");
			}
			break;
		case (RICKY):
		case (JUANE):
		case (ZAFFO):
			if (num == 0) {
				strcpy(nave_dat, "Naves/Caza/nave_1.dat");
				strcpy(nave_pic, "Naves/Caza/nave_1.png");
			} else {
				strcpy(nave_dat, "Naves/Caza/nave_2.dat");
				strcpy(nave_pic, "Naves/Caza/nave_2.png");
			}
			break;
	}
	fp = fopen(nave_dat, "r");
	if (fp != NULL) {
		fscanf(fp, "%i", &total_pos);
		pos_imagen = new SDL_Rect[total_pos];
		for(int i=0; i<total_pos; i++)
		{
			fscanf(fp, "%i %i %i %i", &x, &y, &w, &h);
			pos_imagen[i].x = x;
			pos_imagen[i].y = y;
			pos_imagen[i].w = w;
			pos_imagen[i].h = h;
		}
		fclose(fp);
	} else {
		Gra_Debug("NaveHumano", "Constructor", "No se pudo abrir info de la nave", CRITICO);
		Gra_Debug("NaveHumano", "Constructor", nave_dat, CRITICO);
		total_pos = 0;
	}
	current_pos = (int)(total_pos/2);
	img_cod = Gra_LoadImage(nave_pic, true);
	/* inicializa posicion */
	pos.setX( Gra_ScreenWidth()/2 );
	pos.setY( 100+SHIP_WIDTH );
	vel.setX(0);
	vel.setY(0);
	radio_choque = (int)(SHIP_WIDTH/2);
	life = SHIP_LIFE;
	damage = 40;
	if (num == 0) {
		ion_pos.x = 12;
		ion_pos.y = 10;
		ion_pos.w = 20;
		ion_pos.h = 100;
		bar_pos.x = 0;
		bar_pos.y = 0;
		bar_pos.w = 10;
		bar_pos.h = 480;
		bar = new EnergyBar(life, EnergyBar::BAR_VERTICAL, Gra_GetColor(0xFF, 0xFF, 0),  100);
		bar->setTexture("Comunes/humano_escudo1.png");
		bar->drawBox(false);
	} else {
		ion_pos.x = 608;
		ion_pos.y = 10;
		ion_pos.w = 20;
		ion_pos.h = 100;
		bar_pos.x = 630;
		bar_pos.y = 0;
		bar_pos.w = 10;
		bar_pos.h = 480;
		bar = new EnergyBar(life, EnergyBar::BAR_VERTICAL, Gra_GetColor(0xFF, 0xFF, 0),  100);
		bar->setTexture("Comunes/humano_escudo2.png");
		bar->drawBox(false);
	}

	ion = new EnergyBar(MAX_ION, EnergyBar::BAR_VERTICAL, Gra_GetColor(0xFF, 0, 0), 50);
	ion->setTexture("Comunes/ion_bar.png");
	calentamiento = 0;
	explode = true;
	ion_cannon = MAX_ION;
	step_pos = 8;

	control->AddObjetoBueno(this);
	piloto = p;
	phaser_sound = Gra_LoadWav("sound/efectos/phaser.wav");
	piloto_numero = num;
	danio_remanente = 0;
}

NaveHumano::~NaveHumano()
{
	delete ion;
	delete bar;
	delete [] pos_imagen;
}

void NaveHumano::Dibujar()
{
	Punto2D pant = current->ScreenPos(pos);
	
	if (danio_remanente) {
		bar->setValor( bar->getValor()-1 );
		danio_remanente--;
	}
	life = bar->getValor();

	Gra_BlitImagen(img_cod, &(pos_imagen[current_pos]), pant);

	bar->Dibujar(bar_pos);

	ion->setValor(ion_cannon);
	ion->Dibujar(ion_pos);
}

void NaveHumano::Motor(float i)
{
	vel.setY(i);
}

void NaveHumano::Alerones(float i)
{
	vel.setX(i);
}

void NaveHumano::Mover()
{
	/* Verifico que el movimiento se puede hacer para no salir de pantalla */
	if (current->CanMoveY(pos+vel*Gra_SpeedFactor(), SHIP_WIDTH))
		pos.setY(pos.Y() + (current->isScrolling()?(vel.Y()+1):vel.Y())*Gra_SpeedFactor());
	else
		pos.setY(pos.Y() + Gra_SpeedFactor()); 

	if (current->CanMoveX(pos+vel*Gra_SpeedFactor(), SHIP_WIDTH))
		pos.setX( pos.X() + vel.X()*Gra_SpeedFactor());

	/* analizo que imagen va ...*/
	if (step_pos > 0)
	{
		step_pos--;
		return;
	}
	if (vel.X()==0)
	{
		if (current_pos > (total_pos/2))
		{
			current_pos--;
			if (current_pos < (total_pos/2))
				current_pos = total_pos/2;
		}
		else if (current_pos < (total_pos/2))
		{
			current_pos++;
			if (current_pos > (total_pos/2))
				current_pos = total_pos/2;
		}
	}
	else if (vel.X() > 0)
	{
		current_pos++;
		if (current_pos > (total_pos-1))
			current_pos = total_pos-1;
	}
	else
	{
		current_pos--;
		if (current_pos<0)
			current_pos = 0;
	}
	step_pos = 8;
}

void NaveHumano::Fire()
{
	if (calentamiento == 0)
	{
		Punto2D pos_tmp = pos;
		pos_tmp.setY(pos_tmp.Y()+RadioChoque()+5);
		pos_tmp.setX(pos.X()+FASER_X_1);
		new Faser(pos_tmp, current, control, false, num_player);
		pos_tmp.setX(pos.X()+FASER_X_2);
		new Faser(pos_tmp, current, control, false, num_player);
		/* */
		if (ion_cannon)
		{
			switch (piloto->Piloto()) {
				case (FERNY):
					pos_tmp = pos;
					pos_tmp += Punto2D(0, RadioChoque()+15);
					new IonCannon(pos+Punto2D(-1*RadioChoque()-15, 0), current, control, false, num_player, Armas::GO_LEFT);
					new IonCannon(pos+Punto2D(1*RadioChoque()+15, 0), current, control, false, num_player, Armas::GO_RIGHT);
				break;
				case (JORGE):
					pos_tmp = pos;
					pos_tmp += Punto2D(0, RadioChoque()+15);
					new IonCannon(pos_tmp, current, control, false, num_player, Armas::GO_LEFTUP);
					new IonCannon(pos_tmp, current, control, false, num_player, Armas::GO_RIGHTUP);
				break;
				case (SAGAR):
					pos_tmp = pos;
					pos_tmp -= Punto2D(0, RadioChoque()+15);
					new IonCannon(pos_tmp, current, control, false, num_player, Armas::GO_LEFTDOWN);
					new IonCannon(pos_tmp, current, control, false, num_player, Armas::GO_RIGHTDOWN);
				break;
				case (JUANE):
				case (ZAFFO):
				case (RICKY):
					pos_tmp = pos;
					pos_tmp += Punto2D(0, RadioChoque()+15);
					new IonCannon(pos_tmp, current, control, false, num_player);
			}
			ion_cannon--;
		}
		calentamiento = SHIP_CALENT;
	}
	else
		calentamiento--;
}

void NaveHumano::Daniar(int i)
{
	/* lo verifico por si i es negativo, que indice que agarre un item de Shield Up */
	if (life>SHIP_LIFE)
		life = SHIP_LIFE;
	
	danio_remanente = i;
}

void NaveHumano::setIon(int i)
{
	ion_cannon += i;
	if (ion_cannon > MAX_ION)
		ion_cannon = MAX_ION;
}

void NaveHumano::Exit()
{
	vel += pos.getDir(Punto2D(Gra_ScreenWidth()/2.00f, -1*(current->Get_OffSide()-Gra_ScreenHeight())))*0.03;
	pos += vel*Gra_SpeedFactor();
}
