/***************************************************************************
                          navehumano.h  -  description
                             -------------------
    begin                : Wed Feb 7 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NAVEHUMANO_H
#define NAVEHUMANO_H

#include "graficos_lib.h"
#include "objetos.h"
#include "niveles.h"
#include "faser.h"
#include "pilotos.h"
#include <SDL.h>
#include "energybar.h"
#include "constantes.h"
#include "ioncannon.h"

/**
  *@author Ricardo Markiewicz
  */

class NaveHumano:public Objetos {
public: 
	NaveHumano(Niveles *niv, Controlador *c, Pilotos *p, int num);
	virtual ~NaveHumano();
	virtual void Dibujar();
	virtual void Daniar(int i);
	void Mover();
	void Motor(float i);
	void Alerones(float i);
	float Motor() { return vel.Y(); }
	float Alerones() { return vel.X(); }
	void Fire();
	inline virtual void Die() { life=-1; }
	void setIon(int i);
	inline int getIon() { return ion_cannon; }
	inline int getPhaserSound() { return phaser_sound; }
	void Exit();
private:
	Punto2D vel;
	int img_cod; /* cod. de la imagen */
	SDL_Rect *pos_imagen;
	int total_pos; /* total de posiciones */
	int current_pos, step_pos;
	EnergyBar *bar; /* vida */
	EnergyBar *ion; /* ion cannon */
	SDL_Rect bar_pos, ion_pos;
	int calentamiento;
	/* variables de las armas */
	int ion_cannon;
	int phaser_sound;
	Pilotos *piloto;
	int piloto_numero;
	int danio_remanente;
};

#endif