/***************************************************************************
                          niveles.cpp  -  description
                             -------------------
    begin                : Sat Feb 10 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "niveles.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

Niveles::Niveles(int _numero, char *player1, char *player2)
{
	int i;
	int num; /* indice textura */
	char nom[11]; /* nombre textura */
	char nivel_path[24];
	numero = _numero;
	
	/* Path del nivel */
	sprintf(nivel_path, "Mapas/Nivel%02i/nivel.txt", numero);

	/*cargo nivel*/
	r_bar.w = 600;
	r_bar.h = 40;
	r_bar.x = 20;
	r_bar.y = 400;
	b_count = 0;
	FILE *fp;
	fp = fopen(nivel_path, "r");
	if (fp == NULL) {
		carga_completa = false;
		return;
	}
	fscanf(fp, "%d\n", &i);
	fscanf(fp, "%[^]\n]", name);
	fgetc(fp);
	Gra_Debug("Niveles", "Constructor", "Iniciando Nivel", COMENTARIO);

	img = Gra_LoadImage("Menu/about.png", false);
	barra = new EnergyBar(i, EnergyBar::BAR_HORIZONTAL, Gra_GetColorA(255, 0, 0,128), 128);
	barra->printText(true);
	barra->setTexture("Comunes/nivel_load.png");

	fscanf(fp, "%i\n", &total_terrenos);
	Update(player1, player2);
	/* cargo las texturas de terreno */
	terrenos_pics = new SDL_Surface *[total_terrenos];
	for(i=0; i<total_terrenos; i++)
	{
		fscanf(fp, "%i %s", &num, nom);
		Update(player1, player2);
		char *pic = new char[26];
		sprintf(pic, "Mapas/Nivel%02i/%s", numero, nom);
		terrenos_pics[num] = Gra_ConvertirFormato( SDL_LoadBMP(pic) );
		delete [] pic;
	}
	/* cargo los decorados */
	fscanf(fp, "%i\n", &total_decorados);
	Update(player1, player2);
	decorados_pics = new SDL_Surface *[total_decorados];
	int col_r, col_g, col_b;
	for(i=0; i<total_decorados; i++)
	{
		fscanf(fp, "%i %s %i %i %i", &num, nom, &col_r, &col_g, &col_b);
		Update(player1, player2);
		char *pic = new char[26];
		sprintf(pic, "Mapas/Nivel%02i/%s", numero, nom);
		decorados_pics[num] = Gra_ConvertirFormato( SDL_LoadBMP(pic) );
		SDL_SetColorKey(decorados_pics[num], SDL_SRCCOLORKEY, Gra_GetColor(col_r, col_g, col_b));
		delete [] pic;
	}
	int lineas_dec, p_x, p_y;
	fscanf(fp, "%i\n", &lineas_dec);
	Update(player1, player2);
	for(i=0; i<lineas_dec; i++)
	{
		fscanf(fp, "%i %i %i\n", &num, &p_x, &p_y);
		Update(player1, player2);
		It_Decorado *tmp = new It_Decorado;
		tmp->cod_decorado = num;
		tmp->pos.x = p_x;
		tmp->pos.y = p_y;
		tmp->pos.w = decorados_pics[num]->w;
		tmp->pos.h = decorados_pics[num]->h;
		tmp->next = NULL;
		decorados.Append(tmp);
	}
	/* cargo las lineas */
	fscanf(fp, "%i", &total_lineas);
	Update(player1, player2);
	mapa = new t_Linea_Mapa[total_lineas];
	for(i=0; i<total_lineas; i++)
	{
		mapa[i] = new int[TILE_WIDTH_COUNT];
		fscanf(fp, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		       &(mapa[i][0]), &(mapa[i][1]), &(mapa[i][2]),
		       &(mapa[i][3]), &(mapa[i][4]), &(mapa[i][5]),
		       &(mapa[i][6]), &(mapa[i][7]), &(mapa[i][8]),
		       &(mapa[i][9]), &(mapa[i][10]), &(mapa[i][11]),
		       &(mapa[i][12]), &(mapa[i][13]), &(mapa[i][14]),
		       &(mapa[i][15]), &(mapa[i][16]), &(mapa[i][17]),
		       &(mapa[i][18]), &(mapa[i][19]));
		Update(player1, player2);
	}
	fclose(fp);
	/* fin carga de archivo */
	Update(player1, player2);
	pos_y = -1;
	carga_completa = true;
}

Niveles::~Niveles()
{
	int i;
	
	if (carga_completa) {
		for(i=0; i<total_terrenos; i++)
			SDL_FreeSurface(terrenos_pics[i]);
		delete [] terrenos_pics;
		for(i=0; i<total_decorados; i++)
			SDL_FreeSurface(decorados_pics[i]);
		delete [] decorados_pics;
	
		for(i=0; i<total_lineas; i++)
			delete [] mapa[i];
		delete [] mapa;
	
		It_Decorado *tmp1;
		for(tmp1 = decorados.First(); tmp1; tmp1 = decorados.First())
		{
			decorados.Delete();
			delete tmp1;
		}
		delete barra;
	}
}

void Niveles::Dibujar()
{
	int i,j;
	int indice; /* primer linea actual a dibujar */
	SDL_Rect pos;
	pos.w = pos.h = TILE_WIDTH;
	pos.x = 0;
	pos.y = Gra_ScreenHeight()-TILE_WIDTH;
	/* tengo que calcular a partir de cual linea dibujo
	y las posiciones para el clipping */
	
	/* indice contiene la primer linea del mapa visible */
	indice = -1*pos_y/TILE_WIDTH;

	if ((pos_y%TILE_WIDTH) == 0) /*son TILE_HEIGHT_COUNT lineas enteras */
	{
		indice++; /* no me acuerdo por que lo hago */
		for(i=indice; (i<(TILE_HEIGHT_COUNT+indice)); i++)
		{
			pos.x = 0;
			for(j=0; j<TILE_WIDTH_COUNT; j++)
			{
				Gra_BlitImagen(terrenos_pics[mapa[i][j]], NULL, &pos);
				pos.x += TILE_WIDTH;
			}
			if (pos.y <= 0) break;
			pos.y -= TILE_WIDTH;
		}
	}
	else /* veo como queda el clipping */
	{
		SDL_Rect clip;
		/* hago el clipping de la primer linea */
		clip.w = TILE_WIDTH;
		clip.h = TILE_WIDTH+pos_y%TILE_WIDTH;
		clip.x = 0;
		clip.y = 0;
		pos.x = 0;
		pos.y -= pos_y%TILE_WIDTH;
		for(i=0; i<TILE_WIDTH_COUNT; i++, pos.x+=TILE_WIDTH)
			Gra_BlitImagen(terrenos_pics[mapa[indice][i]], &clip, &pos);
		/* ahora imprimo los demas */
		for(i=indice+1; (i<(indice+TILE_WIDTH_COUNT-4)); i++)
		{
			pos.x = 0;
			for(j=0; j<TILE_WIDTH_COUNT; j++)
			{
				Gra_BlitImagen(terrenos_pics[mapa[i][j]], NULL, &pos);
				pos.x += TILE_WIDTH;
			}
			if (pos.y <= 0) break;
			pos.y -= TILE_WIDTH;
		}
		/* hago el clipping de la parte de arriba */
		if (i<total_lineas)
		{
			pos.y = 0;
			clip.w = TILE_WIDTH;
			clip.h = TILE_WIDTH;
			clip.x = 0;
			clip.y = TILE_WIDTH + pos_y%TILE_WIDTH;
			for(pos.x=0, j=0; j<TILE_WIDTH_COUNT; j++, pos.x+=TILE_WIDTH)
				Gra_BlitImagen(terrenos_pics[mapa[i][j]], &clip, &pos);
		}
	} /* End if-else */
	
	/* Aca termino el primer layer ..(complicado, no?)
	Ahora pongo los decorados, o sea el Layer 2*/
	SDL_Rect rect;
	for(It_Decorado *dec=decorados.First(); dec; )
	{
		rect = ScreenPos(dec->pos);
		rect.w = decorados_pics[dec->cod_decorado]->w;
		rect.h = decorados_pics[dec->cod_decorado]->h;
		if ((rect.x > 0) && (rect.x < Gra_ScreenWidth()) && (rect.y+rect.h > 0) && (rect.y < Gra_ScreenHeight()))
			Gra_BlitImagen(decorados_pics[dec->cod_decorado], NULL, &rect);
		else {
			if (rect.y > Gra_ScreenHeight()) {
				/* lo tengo que borrar, ya no se usa mas */
				decorados.Delete();
				delete dec;
				dec = decorados.At();
				continue; /* como Delete me pasa al siguiente ya no lo muevo a mano */
			}
		}
		/* Muevo al siguiente, o sea que no borre nada */
		dec=decorados.Next();
	}
}

void Niveles::Mover()
{
	if (isScrolling())
		pos_y -= (int)(Gra_SpeedFactor());
}

bool Niveles::CanMoveX(Punto2D pos, Uint16 w)
{
	Punto2D tmp = ScreenPos(pos);
	if (((tmp.X()-w/2) > 0) && ((tmp.X()+w/2) < Gra_ScreenWidth()))
		return true;
	return false;
}

bool Niveles::CanMoveY(Punto2D pos, Uint16 w)
{
	Punto2D tmp = ScreenPos(pos);
	if (((tmp.Y()-w/2) > 0) && ((tmp.Y()+w/2) < Gra_ScreenHeight()))
		return true;
	return false;
}

Punto2D Niveles::ScreenPos(Punto2D pos)
{
	Punto2D tmp = pos;
	tmp.setY( Gra_ScreenHeight() - pos.Y() - pos_y );
	return tmp;
}

SDL_Rect Niveles::ScreenPos(SDL_Rect pos)
{
	SDL_Rect tmp = pos;
	tmp.y = Gra_ScreenHeight() - pos.y - pos_y;
	return tmp;
}

bool Niveles::isScrolling()
{
	return ((total_lineas+pos_y/TILE_WIDTH) > (TILE_HEIGHT_COUNT+1));
}

bool Niveles::isInside(Objetos *obj)
{
	register Punto2D tmp = ScreenPos(obj->Pos());
	if ((tmp.X()>=0) && (tmp.X()<=Gra_ScreenWidth())
	&& (tmp.Y()+obj->RadioChoque()>=0) && (tmp.Y()-obj->RadioChoque()<=Gra_ScreenHeight()))
		return true;
	return false;
}

void Niveles::Update(char *n, char *n1)
{
	static SDL_Color b = {0, 0, 0, 0};
	Gra_BlitImagen(img, NULL, NULL);
	Gra_Print(ALIGN_H_CENTER, 150, FONT_CREDITS, &b, -1, false, "Cargando Nivel ...");
	if (n1 != NULL)
		Gra_Print(ALIGN_H_CENTER, 200, FONT_CREDITS, &b, -1, false, "Pilotos: %s y %s", n, n1);
	else
		Gra_Print(ALIGN_H_CENTER, 200, FONT_CREDITS, &b, -1, false, "Piloto: %s", n);
	barra->setValor(b_count++);
	barra->Dibujar(r_bar);
	Gra_Update();
}
