/***************************************************************************
                          notebook.cpp -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "notebook.h"

Tab::Tab(char *s)
{
	visible = false;
	name = new char[strlen(s)+1];
	strcpy(name, s);
}

Tab::~Tab()
{
	delete [] name;
	while (objetos.First())
		objetos.Delete();
}

void Tab::Visible(bool o)
{
	visible = o;
	FormObj *tmp;
	for(tmp=objetos.First(); tmp; tmp=objetos.Next())
		tmp->Visible(o);
}

bool Tab::isInside(int x, int y)
{
	if ((x>r.x) && (x<r.x+r.w) && (y>r.y) && (y<r.y+r.h))
		return true;
	return false;
}

NoteBook::NoteBook(Form *form, int x, int y, int w, int h):FormObj(form)
{
	r.x = x;
	r.y = y;
	r.w = w;
	r.h = Gra_TextHeight(FONT_TIMES, "M"); /* para que solo tome los Tabs */
	frame.x = x;
	frame.y = y+r.h+4;
	frame.w = w;
	frame.h = h-r.h-4;
	can_focus = true;
}

NoteBook::~NoteBook()
{
	Tab *tmp;
	while ((tmp=tabs.First())) {
		delete tmp;
		tabs.Delete();
	}
}
	
void NoteBook::Dibujar(bool focus)
{
	int x, w, h;
	x = r.x;
	
	Tab *tmp;
	Gra_DrawBox3D(frame.x, frame.y, frame.w, frame.h, 0, 0, false, T3D_OUT);
	for(tmp=tabs.First(); tmp; tmp=tabs.Next()) {
		w = tmp->w();
		h = tmp->h();
		if (tmp == selected) {
			if (focus) {
				Gra_DrawBox3D(x, r.y, w, h, 0, Gra_GetColor(200, 200, 200), true, T3D_OUT);
				Gra_DrawBox(x, r.y+h, w, 5, Gra_GetColor(200,200,200), Gra_GetColor(200,200,200), true);
			}
			else {
				Gra_DrawBox3D(x, r.y, w, h, 0, 0, false, T3D_OUT);
				Gra_DrawBox(x, r.y+h, w, 5, Gra_GetColor(200,200,200), Gra_GetColor(200,200,200), true);
			}
		}
		else {
			Gra_DrawBox3D(x, r.y, w, h, 0, 0, false, T3D_OUT);
			Gra_DrawBox(x, r.y+h, w, 2, Gra_GetColor(200,200,200), Gra_GetColor(200,200,200), true);
		}
		if ((tmp==selected) && (focus))
			Gra_Print(x+2, r.y, FONT_TIMES, &parent->text_focus, -1, false, tmp->Name());
		else
			Gra_Print(x+2, r.y, FONT_TIMES, &parent->text_normal, -1, false, tmp->Name());
		x += w+3;
	}
}

void NoteBook::setFocus()
{
}

void NoteBook::eventKeyDown(SDL_KeyboardEvent *)
{
}

void NoteBook::eventKeyUp(SDL_KeyboardEvent *)
{
}

void NoteBook::eventMouseDown(SDL_MouseButtonEvent *)
{
}

void NoteBook::eventMouseUp(SDL_MouseButtonEvent *e)
{
	Tab *tmp;
	for(tmp=tabs.First(); tmp; tmp=tabs.Next()) {
		if (tmp->isInside(e->x, e->y)) {
			selected->Visible(false);
			selected = tmp;
			selected->Visible(true);
			break;
		}
	}
}

void NoteBook::eventMouseMove(SDL_MouseMotionEvent *)
{
}

void NoteBook::addTab(Tab *t)
{
	Tab *tmp;
	tmp = tabs.Last();
	if (tmp == NULL) {
		t->x(r.x);
		t->y(r.y);
		t->w( Gra_TextWidth(FONT_TIMES, t->Name()) + 5 );
		t->h( Gra_TextHeight(FONT_TIMES, t->Name()) );
	} else {
		t->x(tmp->x()+tmp->w()+2);
		t->y(r.y);
		t->w( Gra_TextWidth(FONT_TIMES, t->Name()) + 5);
		t->h( Gra_TextHeight(FONT_TIMES, t->Name()) );
	}
	tabs.Append(t);
	selected = tabs.First();
}
