/***************************************************************************
                          option.cpp  -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "option.h"

Option::Option(Form *p, int x, int y, int f):FormObj(p)
{
	r.x = x;
	r.y = y;
	r.w = 0;
	r.h = 0;
	fuente = f;
	activo = 0;
}

Option::~Option()
{
	char **o;
	for(o=opciones.First(); o; ) {
		opciones.Delete();
		delete [] *o;
		delete o;
		o = opciones.First();
	}
}

void Option::Dibujar(bool focus)
{
	SDL_Rect dst;
	char **tmp;
	int y = r.y, ind;
	int f_h = 20; //Gra_TextHeight(fuente, "LaTeX");
	for(ind=0, tmp=opciones.First(); tmp; tmp=opciones.Next(), ind++) {
		if (focus)
			Gra_Print(r.x + f_h+1, y+2, fuente, (ind==activo)?(&parent->text_focus):(&parent->text_normal),-1,false,*tmp);
		else
			Gra_Print(r.x + f_h+1, y+2, fuente, &parent->text_normal, -1, false, *tmp);
		
		/* Posicion de la Imagen si existe */
		dst.x = r.x;
		dst.y = y;
		dst.w = 20;
		dst.h = 20;

		if (ind == activo) {
			if (parent->option_select == -1)
				Gra_DrawBox3D(r.x, y+4, f_h-9, f_h-9, 0, 0, true);
			else
				Gra_BlitImagen(parent->option_select, NULL, &dst);
		} else {
			if (parent->option_normal == -1)
				Gra_DrawBox3D(r.x, y+4, f_h-9, f_h-9, 0, 0, false);
			else
				Gra_BlitImagen(parent->option_normal, NULL, &dst);
		}
		y += f_h;
	}
}

void Option::setFocus()
{
}

void Option::eventKeyDown(SDL_KeyboardEvent *)
{
}

void Option::eventKeyUp(SDL_KeyboardEvent *key)
{
	if (key->keysym.sym == SDLK_UP)
		activo--;
	if (key->keysym.sym == SDLK_DOWN)
		activo++;
	Value(activo);

}

void Option::eventMouseDown(SDL_MouseButtonEvent *e)
{
}

void Option::eventMouseUp(SDL_MouseButtonEvent *e)
{
	if (!isMouseOver(e->x, e->y)) return;

	if (e->button == SDL_BUTTON_LEFT)
		activo = (e->y-r.y) / (r.h/opciones.Count());
}

void Option::eventMouseMove(SDL_MouseMotionEvent *e)
{
}

void Option::addOption(char *c)
{
	char **t = new char *;
	*t = new char[strlen(c)+1];
	strcpy(*t, c);
	opciones.Append(t);
	r.h += 20; //Gra_TextHeight(fuente, c);
	if (r.w < Gra_TextWidth(fuente, c))
		r.w = Gra_TextWidth(fuente, c)+20;
}

void Option::Value(int i)
{
	activo = i;
	if (activo < 0) activo = 0;
	if (activo >= opciones.Count()) activo = opciones.Count()-1;
}
