/***************************************************************************
                          scriptparser.cpp  -  description
                             -------------------
    begin                : Sun Mar 18 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "scriptparser.h"
char *readLine(FILE *fp);

ScriptParser::ScriptParser()
{
	script = NULL;
}

ScriptParser::~ScriptParser()
{
	t_Script_File *tmp_file, *del1;
	t_Script_Block *tmp_block, *del2;
	for(tmp_file=script; tmp_file; tmp_file = tmp_file->next)
	{
		for(tmp_block=tmp_file->block; tmp_block; )
		{
			del2 = tmp_block;
			tmp_block=tmp_block->next;
			delete [] del2->line;
			delete del2;
		}
		del1 = tmp_file;
		tmp_file = tmp_file->next;
		delete [] del1->name;
		delete del1;
	}
}

int ScriptParser::LoadScript(char *filename)
{
	FILE *fp = fopen(filename, "r");
	if (fp == NULL)
	{
		fprintf(stderr, "ScriptParser::LoadScript : No se pudo abrir \"%s\"\n", filename);
		return -1;	
	}
	while (!feof(fp))
	{
		char *s=readLine(fp);
		if ((s[0] == '\n') || (s[0] == '#')) /* linea al pedo, la elimino */
		{
			delete [] s;
			continue;
		}
		if (s[0] == '@')
		{
			char s1[10]; /* tipo de evento */
			char s2[10]; /* nombre evento */
			t_Script_File *tmp = new t_Script_File;
			tmp->next = NULL;
			sscanf(s, "%s %s", s1, s2);
			/* guardo el nombre */
			tmp->name = new char[strlen(s2)+1];
			strcpy(tmp->name, s2);
			if (strcmp(s1, "@NORMAL")==0)
				tmp->type= TYPE_NORMAL;
			tmp->block = readBlock(fp);
			if (tmp->block == NULL)
			{
				fprintf(stderr, "ScriptParser::LoadScript : error al leer el archivo. Formato desconocido\n");
				return -1; /* error critico al leer el archivo !! */
			}
			if (script == NULL)
				script = tmp;
			else
			{
				tmp->next = script;
				script = tmp;
			}
		}
	}
	fclose(fp);
	return 0;
}

int ScriptParser::CallEvent(int event)
{
	return 0;
}

void ScriptParser::CmdIf(char *line)
{
}

void ScriptParser::CmdDo()
{
}

void ScriptParser::CmdFor()
{
}

void ScriptParser::CmdWhile()
{
}

t_Script_Block *ScriptParser::readBlock(FILE *fp)
{
	t_Script_Block *tmp, *block=NULL;
	char *s = readLine(fp);
	if (s[0] != '{')
	{
		printf("ScriptParser::readBlock: Formato del archivo incorrecto!!\n%s\n ", s);
		delete [] s;
		return NULL;
	}
	delete [] s;
	while (!feof(fp))
	{
		unsigned int i;
		s = readLine(fp);
		if (s[0] == '}') break;
		/* tengo que detectar que tipo de instruccion es y ver como guardarla */
		for(i=0; i< strlen(s); i++)
			if (isspace(s[i]) == 0)
				break;
		tmp = new t_Script_Block;
		tmp->next = NULL;
		tmp->line = new char[strlen(s)-i+1];
		strcpy(tmp->line, s+i);
		if (block == NULL)
			block = tmp;
		else
		{
			/* tengo que agregar al final para mantener el orden !! */
			t_Script_Block *tmp1;
			for(tmp1 = block; (tmp1->next )!= NULL; tmp1=tmp1->next) ;
			tmp1->next = tmp;
		}
		delete [] s;
	}
	return block;
}

char *readLine(FILE *fp)
{
	/* maxima cantidad de caracteres por linea */
	char l_tmp[255];
	char *out;
	fscanf(fp, "%[^]\n]", l_tmp); /* leo la linea hasta el \n */
	fgetc(fp); /* leo el \n para que anda :-) */
	out = new char[strlen(l_tmp)+1];
	if (out == NULL)
			return NULL;
	memcpy(out, l_tmp, sizeof(char)*(strlen(l_tmp)+1));
	return out;
}