/***************************************************************************
                          slider.cpp -  description
                             -------------------
    begin                : Sat Feb 24 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "slider.h"

Slider::Slider(Form *p, int x, int y, int w, int h, int max):FormObj(p) {
	draw.x = x;
	r.x = x+h;
	draw.y = r.y = y;
	draw.w = w;
	r.w = w-h*2;
	draw.h = r.h = h;
	maximo = max;
	actual = 0;
	btnPrev = new Button(p, draw.x+3, draw.y+3, draw.h-3, draw.h-4, FONT_TIMES, "<", PREV);
	btnPrev->connect(this, PREV);
	btnNext = new Button(p, draw.x+draw.w-draw.h, draw.y+3, draw.h-3, draw.h-4, FONT_TIMES, ">", NEXT);
	btnNext->connect(this, NEXT);
}

Slider::~Slider()
{
}
	
void Slider::Dibujar(bool focus)
{
	int llenar = (int)(((r.w-r.h*2))*((float)actual/maximo));
	if (focus)
		Gra_DrawBox(draw.x+draw.h-1,draw.y+1,llenar,draw.h-2, 0, Gra_GetColor(0xFF,0,0),true);
	else
		Gra_DrawBox(draw.x+draw.h-1,draw.y+1,llenar,draw.h-2, 0, Gra_GetColor(0,0,0xFF),true);
	Gra_DrawBox3D(draw.x,draw.y,draw.w,draw.h);
}

void Slider::setFocus()
{
}

void Slider::eventKeyDown(SDL_KeyboardEvent *)
{
}

void Slider::eventKeyUp(SDL_KeyboardEvent *e)
{
	switch (e->keysym.sym) {
		case (SDLK_LEFT):
			setValue(--actual);
			break;
		case (SDLK_RIGHT):
			setValue(++actual);
			break;
		case (SDLK_HOME):
			setValue(0);
			break;
		case (SDLK_END):
			setValue(maximo);
	}
}

void Slider::eventMouseDown(SDL_MouseButtonEvent *)
{
}

void Slider::eventMouseUp(SDL_MouseButtonEvent *e)
{
	if ((e->y>=r.y) && (e->y<=(r.y+r.h)) && (e->x>=r.x) && (e->x<=(r.x+r.w))) { /* esta dentro */
		if (e->button == SDL_BUTTON_LEFT)
			setValue(actual-5);
		else if (e->button == SDL_BUTTON_RIGHT)
			setValue(actual+5);
	}
}

void Slider::eventMouseMove(SDL_MouseMotionEvent *)
{
}

void Slider::setValue(int a)
{
	actual = a;
	if (a<0) actual=0;
	if (a>maximo) actual = maximo;
}

void Slider::receiveMessage(FormObj *o, int cod)
{
	switch (cod) {
		case (NEXT):
			setValue(++actual);
			setFocus();
			parent->setFocus(this);
		break;
		case (PREV):
			setValue(--actual);
			setFocus();
			parent->setFocus(this);
	}
}

void Slider::Visible(bool o)
{
	visible = o;
	btnNext->Visible(o);
	btnPrev->Visible(o);
}
