/***************************************************************************
                          startgame.cpp  -  description
                             -------------------
    begin                : mi feb  7 01:50:28 ART 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "startgame.h"
#include "new_pilot..h"

extern void DrawOption(void); /* Dibuja el fondo ... */
int ResetPilot(void);

/* Objectos que voy a usar */


void lstPiloto::receiveMessage(FormObj *who, int code)
{
	Pilotos *tmp;
	List::receiveMessage(who, code);
	switch (code) {
		case (FormObj::CLICKED_EVENT):
			Clean();
			for(tmp=l->First(); tmp; tmp=l->Next())
				addItem(tmp->Name());
			break;
		case (FormObj::DELETE_CURRENT_EVENT):
			if (l->Count() == 0) {
				Gra_Debug("Engine", "Pilotos", "No hay pilotos", WARNING);
				return;
			}
			for(tmp=l->First(); tmp; tmp=l->Next()) {
				if (strcmp(tmp->Name(), Value()) == 0) {
					l->Delete();
					delete tmp;
					break;
				}
			}
			receiveMessage(this, FormObj::CLICKED_EVENT);
		break;
		case (FormObj::RESET_CURRENT_PILOTO):
			for(tmp=l->First(); tmp; tmp=l->Next()) {
				if (strcmp(tmp->Name(), Value()) == 0) {
					tmp->Score(0);
					tmp->Level(1);
					sendMessage(SELECT_EVENT);
					break;
				}
			}
	}
}

void picPiloto::receiveMessage(FormObj *o, int code)
{
	/* Espero una seleccion de imagen */
	char *txt;
	Pilotos *tmp;
	List *l = (List *)o;
	txt = l->Value();
	if (txt == NULL) {
		cod_img = -1;
		return; /* No hay pilotos en la lista!! */
	}
	for(tmp=lst_pil.First(); tmp; tmp=lst_pil.Next()) {
		if (strcmp(txt, tmp->Name()) == 0) {
			/* Tengo el archivo del piloto :-) */
			cod_img = tmp->face();
			break;
		}
	}
}

void lblNivel::receiveMessage(FormObj *o, int code)
{
	Pilotos *tmp;
	lstPiloto *lst = (lstPiloto *)o;
	Lista<Pilotos> *l = lst->getItemList();
	
	if (code == FormObj::SELECT_EVENT) {
		if (l->Count() == 0) {
			if (texto != NULL)
				delete [] texto;
			texto = new char[5];
			sprintf(texto, "    ");
			return;
		}
		
		/* busco el piloto seleccinado */
		for(tmp=l->First(); tmp; tmp=l->Next()) {
			if (strcmp(tmp->Name(), lst->Value()) == 0) {
				/* Lo tengo !! */
				if (texto != NULL)
					delete [] texto;
				texto = new char[5];
				sprintf(texto, "% 4d", tmp->Level());
				texto[4] = '\0';
			}
		}
	}
}

void lblScore::receiveMessage(FormObj *o, int code)
{
	Pilotos *tmp;
	lstPiloto *lst = (lstPiloto *)o;
	Lista<Pilotos> *l = lst->getItemList();
	
	if (code == FormObj::SELECT_EVENT) {
		if (l->Count() == 0) {
			if (texto != NULL)
				delete [] texto;
			texto = new char[5];
			sprintf(texto, "    ");
			return;
		}
	
		/* busco el piloto seleccinado */
		for(tmp=l->First(); tmp; tmp=l->Next()) {
			if (strcmp(tmp->Name(), lst->Value()) == 0) {
				/* Lo tengo !! */
				if (texto != NULL)
					delete [] texto;
				texto = new char[10];
				sprintf(texto, "% 9li", tmp->Score());
				texto[9] = '\0';
			}
		}
	}
}

lblList::lblList(Form *p, int x, int y, int w, int h, int f):List(p, x, y, w, h, f)
{
	int i,j;
#ifdef LINUX
	DIR *dir;
	struct dirent *level;
	dir = opendir("Mapas");
	total=0;
	while ((level=readdir(dir)) != NULL) {
		if (level->d_name[0] != '.') {
			nombres[total] = new char[strlen(level->d_name)+1];
			strcpy(nombres[total++], level->d_name);
		}
	}
	closedir(dir);
#endif
#ifdef WIN32
	_finddata_t data;
	long dir;
	dir = _findfirst("Mapas/*.*", &data);
	total = 0;
	if (data.attrib & _A_SUBDIR) {
		if (data.name[0] != '.') {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	while (_findnext(dir, &data) == 0) {
		if ((data.attrib & _A_SUBDIR) && (data.name[0] != '.')) {
			nombres[total] = new char[strlen(data.name)+1];
			strcpy(nombres[total++], data.name);
		}
	}
	_findclose(dir);
#endif
	
	/* Ordeno los directorios */
	char *tmp;
	for(i=0; i<total-1; i++)
		for(j=i+1; j<total; j++)
			if (strcmp(nombres[i], nombres[j]) > 0) {
				tmp = nombres[i];
				nombres[i] = nombres[j];
				nombres[j] = tmp;
			}
	/* Agrego ..*/
	for(i=0; i<total; i++)
		addItem(nombres[i]);
	can_focus=true;
}

lblList::~lblList()
{
	int i;
	for(i=0; i<total; i++)
		delete [] nombres[i];
}

void lblList::receiveMessage(FormObj *o, int code)
{
	List::receiveMessage(o, code);
}

/* Aca se elige el piloto (o se crean/borran) para 
empezar a jugar .. */
Pilotos *StartCampaing_1()
{
	int n;
	Form *form;
	lstPiloto *lst_pilotos;
	Button *start, *cancel, *add, *del, *reset;
	picPiloto *p;
	lblNivel *level; /* Texto de Nivel */
	lblScore *score;
	Label *clevel, *cscore; /* Caption */
	
	form = new Form(&DrawOption);

	lst_pilotos = new lstPiloto(form, 60, 150, 140, 8, FONT_TIMES);
	lst_pilotos->setItemList(&lst_pil);
	lst_pilotos->receiveMessage(NULL, FormObj::CLICKED_EVENT);

	p = new picPiloto(form, 350, 150, 100, 100);
	lst_pilotos->connect(p, FormObj::SELECT_EVENT);

	clevel = new Label(form, 460, 150, FONT_TIMES, Gra_Idioma_Get(0));
	level = new lblNivel(form, 460+clevel->width(), 150, FONT_TIMES, NULL);
	
	cscore = new Label(form, 460, 170, FONT_TIMES, Gra_Idioma_Get(1));
	score = new lblScore(form, 460+cscore->width(), 170, FONT_TIMES, NULL);
	
	lst_pilotos->connect(score, FormObj::SELECT_EVENT);
	lst_pilotos->connect(level, FormObj::SELECT_EVENT);

	add = new Button(form, 210, 150, 130, 20, FONT_TIMES, Gra_Idioma_Get(2));
	add->OnClick(&CreatePilot);
	add->connect(lst_pilotos, FormObj::CLICKED_EVENT);
	add->setAlign(TEXT_CENTER);

	del = new Button(form, 210, 180, 130, 20, FONT_TIMES, Gra_Idioma_Get(3), FormObj::DELETE_CURRENT_EVENT);
	del->connect(lst_pilotos, FormObj::DELETE_CURRENT_EVENT);
	del->setAlign(TEXT_CENTER);
	
	reset = new Button(form, 210, 210, 130, 20, FONT_TIMES, Gra_Idioma_Get(4));
	reset->OnClick(&ResetPilot);
	reset->connect(lst_pilotos, FormObj::RESET_CURRENT_PILOTO);
	reset->setAlign(TEXT_CENTER);

	start = new Button(form, 60, 155+lst_pilotos->height(), 140, 20, FONT_TIMES, Gra_Idioma_Get(5), Form::OK);
	start->setAlign(TEXT_CENTER);
	cancel = new Button(form, 520, 350, FONT_TIMES, Gra_Idioma_Get(6), Form::CANCEL);
	
	n = form->Go();
	
	/* Accion Cancelada */
	if (n == Form::CANCEL) {
		delete form;
		return NULL;
	}

	Pilotos *tmp;
	/* Busco el piloto en la lista y luego lo devuelvo */
	for(tmp=lst_pil.First(); strcmp(tmp->Name(), lst_pilotos->Value()) != 0; tmp=lst_pil.Next()) ;

	delete form;

	return tmp;
}

void StartCampaing_2(int *p1, int *p2)
{
	Form *form;
	Label *lbl1, *lbl2, *color1, *color2;
	Button *ok, *cancel;
	Selector *pil1, *pil2;
	
	form = new Form( &DrawOption );
	
	lbl1 = new Label(form, 100, 150, FONT_COMIC, Gra_Idioma_Get(7));
	lbl2 = new Label(form, 400, 150, FONT_COMIC, Gra_Idioma_Get(8));
	
	pil1 = new Selector(form, 100, 150+lbl1->height()+5, 100, 100);
	pil1->addPicture("pilotos/ferny.png");
	pil1->addPicture("pilotos/jorge.png");
	pil1->addPicture("pilotos/ricky.png");
	pil1->addPicture("pilotos/juane.png");
	pil1->addPicture("pilotos/sagar.png");
	pil1->addPicture("pilotos/zaffo.png");

	color1 = new Label(form, 130, 280, FONT_ARIAL, Gra_Idioma_Get(9));
	
	pil2 = new Selector(form, 400, 150+lbl2->height()+5, 100, 100);
	pil2->addPicture("pilotos/ferny.png");
	pil2->addPicture("pilotos/jorge.png");
	pil2->addPicture("pilotos/ricky.png");
	pil2->addPicture("pilotos/juane.png");
	pil2->addPicture("pilotos/sagar.png");
	pil2->addPicture("pilotos/zaffo.png");

	color2 = new Label(form, 430, 280, FONT_ARIAL, Gra_Idioma_Get(10));
	
	ok = new Button(form, 50, 350, FONT_TIMES, Gra_Idioma_Get(11), Form::OK);
	cancel = new Button(form, 520, 350, FONT_TIMES, Gra_Idioma_Get(12), Form::CANCEL);

	if (form->Go() == Form::CANCEL) {
		*p1 = -1;
		*p2 = -1;
		delete form;
		return;
	}
	
	*p1 = pil1->Value();
	*p2 = pil2->Value();
	
	delete form;

	return;
}

void StartSingleLevel(int *p1, int *p2, int *lbl)
{
	Form *form;
	lblList *level;
	Button *ok, *cancel;
	Selector *player1, *player2;
	Label *llevel, *lplayer1, *lplayer2;
	CheckBox *dual_player;

	form = new Form(&DrawOption);
	
	llevel = new Label(form, 50, 150, FONT_COMIC, Gra_Idioma_Get(13));
	level = new lblList(form, 50, 180, 120, 8, FONT_TIMES);
	
	lplayer1 = new Label(form, 300, 150, FONT_COMIC, Gra_Idioma_Get(7));
	player1 = new Selector(form, 300, 180, 100, 100);
	player1->addPicture("pilotos/ferny.png");
	player1->addPicture("pilotos/jorge.png");
	player1->addPicture("pilotos/ricky.png");
	player1->addPicture("pilotos/juane.png");
	player1->addPicture("pilotos/sagar.png");
	player1->addPicture("pilotos/zaffo.png");

	lplayer2 = new Label(form, 430, 150, FONT_COMIC, Gra_Idioma_Get(8));
	player2 = new Selector(form, 430, 180, 100, 100);
	player2->addPicture("pilotos/ferny.png");
	player2->addPicture("pilotos/jorge.png");
	player2->addPicture("pilotos/ricky.png");
	player2->addPicture("pilotos/juane.png");
	player2->addPicture("pilotos/sagar.png");
	player2->addPicture("pilotos/zaffo.png");

	dual_player = new CheckBox(form, 430, 285, FONT_TIMES, Gra_Idioma_Get(14), true);

	ok = new Button(form, 50, 350, FONT_TIMES, Gra_Idioma_Get(11), Form::OK);
	cancel = new Button(form, 520, 350, FONT_TIMES, Gra_Idioma_Get(12), Form::CANCEL);

	if (form->Go() == Form::CANCEL) {
		*p2 = *p1 = -1;
		*lbl = -1;
		delete form;
		return;
	}

	*p1 = player1->Value();
	if (dual_player->Value())
		*p2 = player2->Value();
	else 
		*p2 = -1;
	*lbl = level->SelectedId()+1;

	delete form;
}

int ResetPilot(void)
{
	if (ConfirmDialog(Gra_Idioma_Get(15), Gra_Idioma_Get(11), Gra_Idioma_Get(12)) == Form::OK)
		return FormObj::RESET_CURRENT_PILOTO;
	
	return -1;
}

t_Juego SeleccionaJuego()
{
	t_Juego n;
	Form *form;
	Label *lbl;
	Option *tipo;
	Button *ok, *cancel;
	
	form = new Form( &DrawOption );
	
	lbl = new Label(form, 150, 180, FONT_COMIC, Gra_Idioma_Get(16));
	
	tipo = new Option(form, 150, 180+lbl->height()+5, FONT_TIMES);
	tipo->addOption(Gra_Idioma_Get(17));
	tipo->addOption(Gra_Idioma_Get(18));
	tipo->addOption(Gra_Idioma_Get(19));
	
	ok = new Button(form, 50, 330, FONT_TIMES, Gra_Idioma_Get(11), Form::OK);
	cancel = new Button(form, 520, 330, FONT_TIMES, Gra_Idioma_Get(12), Form::CANCEL);
	
	switch (form->Go()) {
		case (Form::OK): {
			switch (tipo->Value()) {
				case (0):
					n = CAMPAING_1;
				break;
				case (1):
					n = CAMPAING_2;
				break;
				case (2):
					n = SINGLE;
			}
			break;
		}
		case (Form::CANCEL):
		case (Form::ERROR):
			n = NONE;
	}
	
	delete form;

	return n;
}
