/***************************************************************************
                          startgame.h  -  description
                             -------------------
    begin                : mi feb  7 01:50:28 ART 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* Aca se elige el piloto (o se crean/borran) para 
empezar a jugar .. */
#include "graficos_lib.h"
#include "form.h"
#include "list.h"
#include "button.h"
#include "selector.h"
#include "textfield.h"
#include "picturebox.h"
#include "constantes.h"
#include "pilotos.h"
#include "label.h"
#include "option.h"
#include "checkbox.h"

#ifdef LINUX
#include <dirent.h>
#include <sys/types.h>
#endif

#ifdef WIN32
#include <io.h>
#endif

#ifndef _START_GAME_H
#define _START_GAME_H

/* Campaa 1 jugador 
Cuenta puntos, salva partida, ec
*/
Pilotos *StartCampaing_1();

/* Campaa 2 jugadores
Solo cuenta puntos, al quedar sin vidas los jugadores termina
y no se puede continuar ... hay que pasar todo de una :-)
*/
void StartCampaing_2(int *p1, int *p2);

/* Juega 1 solo nivel
Puede ser 1 o 2 jugadores, solo cuenta puntos del nivel y nada mas
Seria como un match a ver quien saca mas putos :-)
*/
void StartSingleLevel(int *p1, int *p2, int *lbl);

/* Ventana para elegir el tipo de juego */
t_Juego SeleccionaJuego();

extern Lista<Pilotos> lst_pil;

class picPiloto: public PictureBox {
public:
	picPiloto(Form *parent, int x, int y, int w, int h):PictureBox(parent,x,y,w,h) {}
	virtual ~picPiloto() {}
	void virtual receiveMessage(FormObj *, int code);
};

class lstPiloto: public List {
public:
	lstPiloto(Form *parent, int x, int y, int w, int lines, int font):List(parent,x,y,w,lines,font) {}
	virtual ~lstPiloto() {}
	void virtual receiveMessage(FormObj *, int code);
	void setItemList(Lista<Pilotos> *_l) { l = _l; }
	inline Lista<Pilotos> *getItemList() { return l; }
protected:
	Lista<Pilotos> *l;
};

class lblNivel:public Label {
public:
	lblNivel(Form *p, int x, int y, int font, char *c):Label(p,x,y,font,c) {}
	virtual ~lblNivel() {}
	virtual void receiveMessage(FormObj *, int code);
};

class lblScore:public Label {
public:
	lblScore(Form *p, int x, int y, int font, char *c):Label(p,x,y,font,c) {}
	virtual ~lblScore() {}
	virtual void receiveMessage(FormObj *, int code);
};

class lblList:public List {
public:
	lblList(Form *p, int x, int y, int w, int h, int f);
	virtual ~lblList();
	virtual void receiveMessage(FormObj *, int code);
private:
	char *nombres[50];
	int total;
};

#endif
