/***************************************************************************
                          torreta.cpp  -  description
                             -------------------
    begin                : Sun Feb 25 2001
    copyright            : (C) 2001 by Ricardo Markiewicz
    email                : gazerzoser@ciudad.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "torreta.h"

Torreta::Torreta(Punto2D pos_ini, Niveles *niv, Controlador *c):Objetos(niv,c,-1)
{
	img_cod = Gra_LoadImage("Estructuras/Torreta/torreta.bmp");
	snd_disparo = Gra_LoadWav("sound/efectos/torreta.wav");
	Gra_SetColorKey(img_cod, 0x00, 0xFF, 0x00);
	pos = pos_ini;
	life = ENEMY_TORRETA_LIFE;
	damage = 30;
	radio_choque = Gra_GetImagenWidth(img_cod)/2;
	calentamiento = 0;
	explode = true;
	puntos = 100;
	control->AddObjetoMalo(this);
	angulo = PI;
}

Torreta::~Torreta()
{
}

void Torreta::Dibujar()
{
	Punto2D tmp = current->ScreenPos(pos);
	Punto2D target;

	target = atacando;
	if (target==Punto2D(0,0))
	{
		/* No hay humanos, Giro para quedar acomodado */
		angulo += 0.1;
		if (angulo > PI)
			angulo = PI;
	}
	else
	{
		/* Calculo el angulo a girar para apuntar el caon */
		target = pos.getDir( target );
		angulo = target.Angulo(Punto2D(0,1));
		
		/* Como la rotacion en [0,PI], roto para el otro lado :-) */
		if (pos.X() > atacando.X())
		 angulo *= -1;
	}
	Gra_BlitRotateImage(img_cod, angulo, tmp, false);
}

void Torreta::Daniar(int dam)
{
	life -= dam;
}

/* como es fija en mover solo calcula 1 disparo */
void Torreta::Mover()
{
	if (!current->isInside(this)) return;
	/* Veo quien esta mas cercar */

	atacando = control->getHumanoCerca(pos);

	if (calentamiento == 0)
	{
		Punto2D target;
		target = atacando;
		if (target == Punto2D(0,0)) return;
		Punto2D init;
		if (pos.dist( target ) <= 500)
		{
			target = pos.getDir( target );
			target *= radio_choque+5;
			init = pos+target;
			Gra_PlayWav(snd_disparo, 0);
			new Faser(init, atacando, current, control, true);
			calentamiento = ENEMY_SHOT;
		}
	}
	else
		calentamiento--;
}